/* wiki.css

   The styles used with the wiki pages of the book. These are kept separate 
   from the stack and book structure styles.
   
   1 June 2026
 */
 
/* defined constants for wiki pages in the guide theme */
 
:root { 
     /* <body class='wiki'> */
  --body-font-family: "Roboto", arial, helvetica, Verdana, sans-serif;
  --body-font-size: 16px; /*15px;*/
  
     /* <section class='bw-cover-page'> */
  --book-cover-width: 1000px;  /* 1000px */
  --book-cover-height: 7.75in; /* min height */
  --book-cover-bg: white;
  --book-cover-fg: black;
  --book-cover-border: #bbb;
  
     /* <section class='wiki-page-trail'> */
  --page-trail-fg: #606060;
  --page-trail-hover: #0000f0;
  --page-trail-size: 10.5pt;   /* 13.3333px   10pt */
  
     /* <nav class='wiki-page-nav'> */
  --page-nav-size: 10pt;
  --page-nav-fg: #606060;
  --page-nav-bg: #eee;
  
  --page-hover-fg: #0000f0;  
  --page-search-fg: #999;
  
     /* <section class='wiki-page-card'> */
  --page-card-width: /*950px;*/  1000px;
  --page-card-bg: white;
  --page-card-border: #bbb;
  
  --page-text-fg: #202020;
  --page-text-size: 16px;  /* 15px */

     /* <div class='wiki-title'> h1 */
  --page-title-fg: #000;
  --page-title-size: 1.8em;
  
     /* <div class='wiki-text'> */
  --wiki-par-margin: 18px;
  
}
 
 


/* Wiki Search */

.wiki-view-page {
  float: right;
  display: inline-block;
}

.wiki-search-results {}

.wiki-search-results .page {
  margin-bottom: 15px;
}

.wiki-search-results .link {
  font-size: 1.2em;
}

.wiki-search-results .path {
  font-size: 0.8em;
  color: var(--page-nav-fg);
  padding-left: 2ex;
}

.wiki-search-results .modified {
  color: var(--page-text-fg);  
  font-size: 0.9em;
  padding-left: 4ex;
}

.wiki-search-results .text {
  color: var(--page-search-fg);
  padding-left: 4ex;
}


/* Wiki Page Structure */

/* ----------------------------------------------------------------
 *  The book and page settings
 * ----------------------------------------------------------------*/

body.wiki.preview {
  zoom: 0.9;
}


body.wiki {
  font-family: var(--body-font-family);
  font-size: var(--body-font-size);
}


body.wiki .bw-bookicon {
  width: 50px;
  padding-top: 2px;
  z-index: 10;
  display: inline-block;
}

body.wiki .bw-bookicon img {
  width: 38px; 
  height: 38px; 
  vertical-align: middle;
}

section.wiki-page-card {
  padding: 0.25in;
  width: var(--page-card-width);
  min-height: calc(100vh - 250px); 
  background-color: var(--page-card-bg);
  border-color: var(--page-card-border);
  box-shadow: 0px 0px 2px 0px #ccc;
  border-radius: 8px;
  margin-left: auto;
  margin-right: auto;  
  margin-bottom: 5px;
  position: relative;
}

section.wiki-page-card.preview {
  margin: 0px;
}

article.wiki-contents {
  box-sizing: border-box;
  padding-left: 30px;
  padding-right: 30px;
  padding-bottom: 1ex;  /* added for space above the last modified text. */
  padding-top: 1px;     /* this is needed to ensure the top-margin of the title remains inside the article element. */
  min-height: 7in;
  font-size: var(--page-text-size);
  color: var(--page-text-fg);
  
}

div.wiki-modified {
  font-size: 0.75em;
  color: var(--stack-footer-fg);
  text-align: right;
}


/* ----------------------------------------------------------------
 *  Table of contents and Sidebar content styles
 * ----------------------------------------------------------------*/

/* Sidebar table of contents. */

body.wiki #overlay {
  position: fixed;
  display: none;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  background-color: rgba(0, 0, 0, 0.5);
  z-index: 300;
  cursor: pointer;
}
 
body.wiki #booktoc {
  width: 350px; 
  border: 1px solid #888; 
  border-top: none;
  background-color: var(--book-toc-body-bg);
  color: var(--page-text-color);
  position: fixed; 
  z-index: 500;
  left:-382px; 
  top: 0;
  bottom: 0;
  margin-top: 0px; /*75px;*/ 
  margin-right: 3px;
  transition: 0.35s;
  white-space: nowrap;
  box-shadow: 2px 4px 4px 0px rgba(0, 0, 0, 0.2), 2px 4px 4px 0 rgba(0, 0, 0, 0.19);
}

body.wiki #booktoc .tocheader {
  background-color: black;
  min-height: 0.75in;
  padding: 8px;
  margin-right: 1px;
}

body.wiki #booktoc .tocheader .icon img {
  width: 40px;
  height: 40px;
}

body.wiki #booktoc .tocheader .icon p {
  color: white;
  display: inline-block;
  float: right;
  font-size: 13px;
}

body.wiki #booktoc .tocheader .title {
  color: white;
  font-weight: 700;
  font-size: 18px;
  margin-top: 4px;
  white-space: normal;
}

body.wiki #booktoc .toctitle {
  display: flex;
  justify-content: center;
  align-items: center;
  min-height: 5ex;
  text-align: center;
  font-size: 1.3em;
  font-weight: bold;
  padding: 2ex 2ex 2ex 2ex;
  color: white; 
  background-color: black;
  white-space: normal;  
}

body.wiki #booktoc .tocauthor { 
  font-family:arial, verdana, sans-serif;
  font-size: 10pt;
  color: var(--book-theme-fg);
  background-color: var(--book-theme-bg);
 
  line-height: 1.2em;
  margin-top: 3ex; 
  padding-top: 1ex;
  padding-bottom: 1ex;
  text-align: center;
  bottom: 0;
  width: 342px;
  white-space: normal;
  border-top: 1px solid #F0F0F0;
}

body.wiki #booktoc .tocauthor a,
body.wiki #booktoc .tocauthor a:visited {
  color: white; /*#808080;*/
}

body.wiki #booktoc .tocauthor a:hover {
  color: #0033F0;
  background-color: transparent;
}

body.wiki #booktoc .tocbody {
  width: 342px;
  font-size: 0.93em;
  line-height: 1.60;
  padding: 1ex;
  padding-left: 0px;
  position: fixed;
  top: 0;
  bottom: 0; 
  margin-top: 112px;
  overflow-x: hidden;
  overflow-y: auto;  
  color: var(--page-text-color);
}

body.wiki #booktoc .tocbody ul {
  list-style-type: square; 
  margin: 0px;
  padding-left: 45px; /*28px;*/
}

body.wiki #booktoc .tocbody ul li a,
body.wiki #booktoc .tocbody ul li a:visited { text-decoration: none; color: #303030; font-weight: normal; }

body.wiki #booktoc .tocbody a:hover,
body.wiki #booktoc .tocbody ul li a:hover {
  text-decoration: none;
  color: #003380; 
  background-color: #ffffcc;    
}


/*
body.wiki #wiki-preview {
  transform: scale(0.9);
  transform-origin: top left; 
}
*/


/* ----------------------------------------------------------------
 *  The book cover page
 * ----------------------------------------------------------------*/


body.cover {}


.bw-cover-page {
  width: var(--book-cover-width);
  margin-left: auto;
  margin-right: auto;
}

.bw-cover-page .footerbar {
  background-color: var(--book-theme-bg);
  height: 12px;  
}

.bw-bookcover {
  margin-left: 30px;
  margin-right: 30px;
  margin-bottom: 25px;  
  padding: 2ex 0.5in 3ex 0.5in;
  min-height: var(--book-cover-height);
  background-color: var(--book-cover-bg);
  color: var(--book-cover-fg);
  border: 1px solid var(--book-cover-border);
  box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.2), 0 4px 4px 0 rgba(0, 0, 0, 0.19), 0 -1px 3px 0 rgba(0, 0, 0, 0.19);
  border-left: 7px solid #888;
}

.bw-bookcover .openbook {
  background-color: #e8e8e8;
  text-align: center;
  min-height: 0.4in;
  margin-bottom: 2.5ex;
}

.bw-bookcover .openbook .click {
  line-height: 0.4in;
  font-weight: normal;
  vertical-align: center;
}

.bw-bookcover .openbook:hover {
  background-color: #ffd320;  
}

.bw-bookcover .title {
  font-size: 26pt;
  font-weight: normal;
}

.bw-bookcover .image {
  text-align: center;
  margin-top: 3ex;
  margin-bottom: 3ex;
}

.bw-bookcover .descp {
  font-size: 11.5pt;
  line-height: 1.4;
  text-align: justify;
}

.bw-bookcover .author {
  text-align: right;
  font-family: 'Times New Roman', serif;
  font-size: 20pt;
  font-style: italic;
  margin-top: 1ex;
}



/* ----------------------------------------------------------------
 *  Page navigation and trail.
 * ----------------------------------------------------------------*/

section.wiki-page-trail {
  font-size: var(--page-trail-size);
  color: var(--page-trail-fg);
  width: var(--page-card-width);
  margin-left: auto;
  margin-right: auto;    
  margin-bottom: 5px;
  text-align: right;
}

section.wiki-page-trail .chevron {
  padding-left: 1ex;
  padding-right: 1ex;
  font-size: 0.9em;
}

section.wiki-page-trail a,
section.wiki-page-trail a:visited {
  color: var(--page-nav-fg);
}

section.wiki-page-trail a:hover {
  color: var(--page-hover-fg);
}

section.wiki-page-card.nav {
  width: calc(var(--page-card-width) + 20px);
  min-height: 10px;
  margin-top: 0px;   /* 5px; */
  margin-bottom: 5px;
  padding-top: 3px;
  padding-bottom: 3px;
  padding-left: 14px;
  padding-right: 14px;
}


div.wiki-hide-nav {
  visibility: hidden;
}

nav.wiki-page-nav {
  display: grid;
  grid-template-columns: 1fr auto 1fr;
  align-items: center;
  width: 100%;
  border: none;
  font-size: var(--page-nav-size);  
}

nav.wiki-page-nav .left {
  justify-self: start;
}

nav.wiki-page-nav .center {
  justify-self: center;
}

nav.wiki-page-nav .right {
  justify-self: end;
}

nav.wiki-page-topnav {
  display: inline-block;
  position: absolute;
  font-size: var(--page-nav-size);    
}

nav.wiki-page-topnav.right {
  right: 5px;
  top: 8px;
}

nav.wiki-page-nav a,
nav.wiki-page-nav a:visited,
nav.wiki-page-topnav a,
nav.wiki-page-topnav a:visited {
  color: var(--page-trail-fg);
}

nav.wiki-page-nav a:hover,
nav.wiki-page-topnav a:hover {
  color: var(--page-trail-hover);
}

nav.wiki-page-nav .arrow,
nav.wiki-page-topnav .arrow {
  display: inline-block;
  width: 24px;
  height: 24px;
  line-height: 24px;
  text-align: center;
  border-radius: 50%;
  background-color: var(--page-nav-bg);  
}

nav.wiki-page-topnav div {
  display: inline-block;
}

nav.wiki-page-topnav .arrow {
/*  background-color: white;*/
 /* border: 1px solid #ddd;
  box-shadow: 0px 0px 2px 0px #f0f0f0; */  
  border-radius: 50%;
}

nav.wiki-page-nav .arrow.left {
  margin-right: 5px;
}

nav.wiki-page-nav .arrow.right {
  margin-left: 5px;
}

nav.wiki-page-topnav .title {
  background-color: var(--page-nav-bg);   
  height: 24px;  
  line-height: 24px;
  padding-left: 1ex;
  padding-right: 1ex;
  border-radius: 6px;
}



/* ----------------------------------------------------------------
 *  The Section edit tab.
 * ----------------------------------------------------------------*/


div.wiki-edittab {
  display: inline-block;
  position: absolute; 
  left: 25px;
  margin-top: -2px;
}

div.wiki-edittab.right {
  right: 25px;  
  left: auto;
}

div.wiki-edittab.float {
  position: relative;
  float: right;
  right: 0;
  left: 0;
  margin-left: 4px;  
}

div.wiki-edittab button.bw-button { 
  padding: 0px;
  background: transparent;
  color: var(--book-theme-bg);
  border: none;
}


div.wiki-edittab button.bw-button:hover {
  color: var(--page-hover-fg);
}



/* ----------------------------------------------------------------
 *  Wiki chapter/page title styles
 * ----------------------------------------------------------------*/

div.wiki-title {
  margin-top: 50px; /*30px;*/ 
  margin-bottom: 3ex;
}

div.wiki-title h1 { 
  font-size: var(--page-title-size);
  color: var(--page-title-fg);
  font-weight: normal;
}

div.wiki-title h1.toplevel {
  border-bottom: 3px solid var(--book-theme-bg);
}

div.wiki-title h1.section {
 /* border-bottom: 3px solid var(--book-theme-bg); */
}


div.wiki-chaphead {
  margin-bottom: 0.6in;
  margin-top: 1in;
  border-bottom: 4px solid var(--book-theme-bg);
}

div.wiki-chaphead .chapnum {
  font-size: 1.25em;
  font-weight: 400;
}

div.wiki-chaphead .chaptitle {
  font-size: 2.1em;
  font-weight: 400;
}


/* ----------------------------------------------------------------
 *  Document Wiki styles
 * ----------------------------------------------------------------*/


/* ------ Wiki header styles -------- */

h2 {
  font-size: 1.6em;
  /*font-weight: normal;*/
  font-weight: 400;
  line-height: 1.4;
  margin-top: 0.5in;
  margin-bottom: 0.25in;
  color: black;
  border-bottom: 2px solid /*#999;*/ var(--book-theme-bg);
  /*color: var(--book-theme-bg);*/ 
/*  
  color: #222;
  border-bottom: 1px solid #aaa;
 */
}

h3 {
  font-size: 1.4em;
  font-weight: 400;
  line-height: 1.4;
  margin-top: 1.5em;
  margin-bottom: 0.4em;
  margin-left: 2px;
  /*color:black;*/
/*  text-decoration: underline;*/
  color: var(--book-theme-bg); 
}

h4 {
  font-size: 1.1em;
  margin-top: 1.5em;
  margin-bottom: 1em;
}

h6 {
  font-size: 1em;
  display: inline;
  font-weight: bold;
}

/* ------ Wiki Text Styles ------ */

div.wiki-text {
  line-height: /*1.5;*/ 1.4;
  margin-top: 10px;
  text-align: justify;
}

div.wiki-text p {
  margin-top: var(--wiki-par-margin);
  margin-bottom: var(--wiki-par-margin);
}

div.wiki-text blockquote {
  font-style: italic;
}


/* ------ Wiki Links ------ */

a.invalid-link {
  color: red;
  text-decoration: underline;
}


/* ------ Verbatim text -------- */
pre {
  line-height: 1.35;
  font-size: 1em;
  font-family: Courier New, Lucida Console, Andale Mono, Courier, monospace;
}


/* ----- horizontal rules -------- */
hr {
  margin-top: 15px;
  margin-bottom: 15px;
  border-color: black;
}

